<div #stepper tabindex="0">
  <nb-card>
    <nb-card-body>
      <nb-stepper orientation="horizontal" [disableStepNavigation]="true" [selectedIndex]="selectedIndex"
                  #nbStepperComponent>
        <nb-step label="Account">
          <h4 class="mb-4">Use account</h4>
          <nb-accordion class="mb-4">
            <nb-accordion-item expanded="true">
              <nb-accordion-item-header>
                Find existing account
              </nb-accordion-item-header>
              <nb-accordion-item-body>
                <label class="d-block">Search for Name or Email
                  <input nbInput [fullWidth]="true" fieldSize="large" (keyup)="searchUser.next($event)"
                         [formControl]="searchUserInputControl"/>
                </label>
                <nb-list *ngIf="userResults$ | async as userResults">
                  <nb-list-item *ngFor="let account of userResults.results">
                    <div class="d-flex justify-content-between">
                      <nb-user [name]="account.username" [title]="account.roles | concatRoles" size="large"
                               [color]="account.locked?'red':''">
                      </nb-user>
                      <button nbButton ghost status="primary" size="giant" (click)="setAccount(account)">
                        <nb-icon icon="arrow-circle-right" title="Use this user"></nb-icon>
                      </button>
                    </div>
                  </nb-list-item>
                </nb-list>
              </nb-accordion-item-body>
            </nb-accordion-item>

            <nb-accordion-item>
              <nb-accordion-item-header>
                Create new account
              </nb-accordion-item-header>
              <nb-accordion-item-body>
                <app-account-form [roles]="roles | async" (save)="storeNewAccount($event)"
                                  [validationErrors]="accountFormValidationErrors"></app-account-form>
              </nb-accordion-item-body>
            </nb-accordion-item>
          </nb-accordion>
        </nb-step>
        <nb-step label="Card">
          <h4 class="mb-4">Assign a card to {{account?.username}}</h4>
          <nb-card>
            <nb-card-body>
              <label class="d-block d-flex">
                <span class="flex-fill align-self-center" style="white-space:nowrap;">Card ID to use</span>
                <input nbInput [fullWidth]="true" class="flex-fill mx-3" [formControl]="cardIdInputControl"
                       fieldSize="large"
                       [status]="!cardIdInputControl.valid && !cardIdInputControl.pristine ? 'danger':'basic' "/>
                <button *ngIf="this.posConnected | async" nbButton size="medium" (click)="useCurrentCard()"
                        class="flex-fill">
                  <nb-icon icon="sync-alt"></nb-icon>&nbsp;&nbsp;Read from card reader
                </button>
              </label>
            </nb-card-body>
          </nb-card>

          <div class="d-flex justify-content-between">
            <button class="order-2" nbButton (click)="saveCard(cardIdInputControl.value)"
                    [disabled]="!cardIdInputControl.valid || cardIdInputControl.pristine">next
            </button>
            <button class="order-1" nbButton (click)="previousPage()">prev</button>
          </div>
        </nb-step>
        <nb-step label="Charge">
          <h4 class="mb-4">Charge the account</h4>
          <nb-card>
            <nb-card-body>
              <label class="d-block d-flex">
              <span class="flex-fill align-self-center"
                    style="white-space:nowrap;">Amount to charge (additionally) onto account in EUR</span>
                <input type="number" nbInput [fullWidth]="true" class="flex-fill mx-3" min="0"
                       [formControl]="chargeAmountInputControl" fieldSize="large"/>
              </label>
            </nb-card-body>
          </nb-card>

          <div class="d-flex justify-content-between">
            <button class="order-2" nbButton (click)="chargeAccount(+chargeAmountInputControl.value)"
                    [disabled]="!chargeAmountInputControl.valid">
              <span *ngIf="chargeAmountInputControl.value > 0">next</span>
              <span *ngIf="chargeAmountInputControl.value <= 0">skip</span>
            </button>
            <button class="order-1" nbButton nbStepperPrevious>prev</button>
          </div>
        </nb-step>
        <nb-step label="Summary">
          <h4 class="mb-4">Summary</h4>
          <nb-card>
            <nb-card-header>{{account?.username}}</nb-card-header>
            <nb-card-body>
              <nb-list>
                <nb-list-item>
                  ID: {{account?.id}}
                </nb-list-item>
                <nb-list-item>
                  Card: {{account?.cardId}}
                </nb-list-item>
                <nb-list-item>
                  Overdraft: {{account?.overdraft | currency:'EUR'}}
                </nb-list-item>
              </nb-list>
            </nb-card-body>
            <nb-card-footer>Balance: {{account?.balance | currency:'EUR'}}</nb-card-footer>
          </nb-card>

          <div class="d-flex justify-content-between">
            <button class="order-2" nbButton (click)="restartWizard(); nbStepperComponent.reset()">
              <nb-icon icon="play-circle"></nb-icon>
              restart wizard
            </button>
            <button class="order-1" nbButton nbStepperPrevious disabled>prev</button>
          </div>
        </nb-step>
      </nb-stepper>
    </nb-card-body>
  </nb-card>
</div>
